package net.osmand.plus.views;

import java.util.List;

import net.osmand.plus.OsmandApplication;
import net.osmand.plus.geoassist.GeoHelper;


abstract public class GeoPluginLayer extends OsmandMapLayer {

	public static GeoPluginLayer getPluginByType(GeoPlugin plugin, OsmandApplication app){
		switch (plugin) {
		case EMDR:
			return new ESBRPluginLayer(app.getGeoHelper());
		default:
			return null;
		}
	}
	
	public enum GeoPlugin {
		EMDR(1)
		;
		
		private final int defaultTag;	
		
		private GeoPlugin(int defaultTag ){
			this.defaultTag=defaultTag;
		}
		
		public int getDefaultTag(){
			return defaultTag;
		}

		public Integer getId() {
			GeoPlugin [] list= GeoPlugin.values();
			int i=0;
			for(GeoPlugin plugin:list){
				if( this == plugin){
					return i;
				}
				i++;
			}
			return i;
		}
		
	}
	
	GeoHelper geoHelper = null;
	
	public GeoPluginLayer(GeoHelper geoHelper) {
		super();
		this.geoHelper = geoHelper;
	}

	
	
	@Override
	public boolean drawInScreenPixels() {
		return true;
	}



	
	public abstract GeoPlugin GetType();

	
}
